                                                                                                                                                                                                                                                                                                                    ##  簡陋
define -2 gui.name_text_outlines = [ (3, "#000000F0", 1, 1) ]
define -2 gui.dialogue_text_outlines = [ (3, "#000000F0", 1, 1) ]
define config.default_music_volume = 0.25
define config.default_sfx_volume = 0.25
define config.default_voice_volume = 0.25

init 998 python:
    def _toggle_quick_menu_q():

        if renpy.has_screen('quick_menu'):
            if not hasattr(store, 'quick_menu'):
                setattr(store, 'quick_menu', True)
                renpy.show_screen('quick_menu')
                setattr(store, 'suppress_overlay', False)
            else:
                if quick_menu == True:
                    setattr(store, 'quick_menu', False)
                    renpy.hide_screen('quick_menu')
                else:
                    setattr(store, 'quick_menu', True)
                    renpy.show_screen('quick_menu')
                    setattr(store, 'suppress_overlay', False)

    config.keymap[ 'toggle_quick_menu_q' ] = [ 'K_q' ]
    config.underlay.append(renpy.Keymap(toggle_quick_menu_q = Function(_toggle_quick_menu_q)))

    if persistent.opacity == None:
        persistent.opacity = 0.

init -500 screen preferences():
    tag menu

    $ renpy.retain_after_load()

    use game_menu(_("Options"), scroll="viewport"):

        vbox:

            hbox:
                box_wrap True

                if renpy.variant("pc") or renpy.variant("web") and not renpy.variant("mobile"):

                    vbox:
                        style_prefix "radio"
                        label _("Display")
                        textbutton _("Window") action Preference("display", "window")
                        textbutton _("Fullscreen") action Preference("display", "fullscreen")

                vbox:
                    style_prefix "radio"
                    label _("Rollback Side")
                    textbutton _("Disable") action Preference("rollback side", "disable")
                    textbutton _("Left") action Preference("rollback side", "left")
                    textbutton _("Right") action Preference("rollback side", "right")

                vbox:
                    style_prefix "check"
                    label _("Skip")
                    textbutton _("Unseen Text") action Preference("skip", "toggle")
                    textbutton _("After Choices") action Preference("after choices", "toggle")
                    textbutton _("Transitions") action InvertSelected(Preference("transitions", "toggle"))

                vbox:
                    style_prefix "check"
                    label _("Language")
                    textbutton _("English") action Language("english")
                    textbutton _("Русский") action Language(None)

                vbox:
                    style_prefix "check"
                    label _("Difficulty")
                    textbutton _("Normal") action SetVariable("dif_level_easy", False)
                    textbutton _("Easy") action SetVariable("dif_level_easy", True)

            null height (4 * gui.pref_spacing)

            hbox:
                style_prefix "slider"
                box_wrap True

                vbox:
                    label _("Text Speed")
                    bar value Preference("text speed")

                    label _("Auto-Forward Time")
                    bar value Preference("auto-forward time")

                vbox:

                    if config.has_music:
                        label _("Music Volume")
                        hbox:
                            bar value Preference("music volume")

                    if config.has_sound:

                        label _("Sound Volume")
                        hbox:
                            bar value Preference("sound volume")

                            if config.sample_sound:
                                textbutton _("Test") action Play("sound", config.sample_sound)


                    if config.has_voice:
                        label _("Voice Volume")
                        hbox:
                            bar value Preference("voice volume")

                            if config.sample_voice:
                                textbutton _("Test") action Play("voice", config.sample_voice)

                    if config.has_music or config.has_sound or config.has_voice:
                        null height gui.pref_spacing

                        textbutton _("Mute All"):
                            action Preference("all mute", "toggle")
                            style "mute_all_button"

### Shaddy Additions ###
                frame:
                    background Solid("#0000BF7F")
                    xcenter 0.5
                    ycenter 0.6
                    xysize (1300,425)
                    add "#000"
                    add Transform("shaddyMod/images/ShaddyBG3.png", zoom=1.1) alpha 0.65 xalign 0.5 #yalign 0.5
                    vbox:
                        xcenter 0.5
                        ycenter 0.5
                        spacing 30
                        hbox:
                            xcenter 0.5
                            spacing 15
                            hbox:
                                spacing -5
                                text "S" at delayed_blink(0.9, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                                text "h" at delayed_blink(0.8, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                                text "a" at delayed_blink(0.7, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                                text "d" at delayed_blink(0.6, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                                text "d" at delayed_blink(0.5, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                                text "y" at delayed_blink(0.4, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                                text "M" at delayed_blink(0.3, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                                text "o" at delayed_blink(0.2, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                                text "d" at delayed_blink(0.1, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                                text "d" at delayed_blink(0.0, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                                text "a" at delayed_blink(0.0, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                            hbox:
                                spacing -5
                                text "A" at delayed_blink(0.1, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                                text "d" at delayed_blink(0.2, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                                text "d" at delayed_blink(0.3, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                                text "i" at delayed_blink(0.4, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                                text "t" at delayed_blink(0.5, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                                text "i" at delayed_blink(0.6, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                                text "o" at delayed_blink(0.7, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                                text "n" at delayed_blink(0.8, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                                text "s" at delayed_blink(0.9, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                        #text _("ShaddyModda Additions") xcenter 0.5 style "shaddyTextBoxHeader"
                        hbox:
                            spacing 50
                            xcenter 0.5
                            ycenter 0.5
                            vbox:
                                style_prefix "navigation"
                                hbox:
                                    spacing -5
                                    text "R" at delayed_blink(0.2, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    text "e" at delayed_blink(0.1, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    text "n" at delayed_blink(0.0, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    text "a" at delayed_blink(0.0, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    text "m" at delayed_blink(0.1, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    text "e" at delayed_blink(0.2, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                #text _("RENAME") style "shaddyTextBody2"
                                textbutton _("Change") action [ui.callsinnewcontext("Rename"), Return()]

                            vbox:
                                style_prefix "radio"
                                hbox:
                                    spacing 15
                                    hbox:
                                        spacing -5
                                        text "Q" at delayed_blink(0.4, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "u" at delayed_blink(0.3, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "i" at delayed_blink(0.2, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "c" at delayed_blink(0.1, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "k" at delayed_blink(0.0, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    hbox:
                                        spacing -5
                                        text "M" at delayed_blink(0.1, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "e" at delayed_blink(0.2, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "n" at delayed_blink(0.3, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "u" at delayed_blink(0.4, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                #text ("QUICK MENU") style "shaddyTextBody2"
                                hbox:
                                    textbutton "Enabled" action ToggleVariable("quick_menu", true_value=True, false_value=False)

                            vbox:
                                style_prefix "check"
                                hbox:
                                    spacing -5
                                    text "W" at delayed_blink(0.5, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    text "a" at delayed_blink(0.4, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    text "l" at delayed_blink(0.3, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    text "k" at delayed_blink(0.2, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    text "t" at delayed_blink(0.1, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    text "h" at delayed_blink(0.0, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    text "r" at delayed_blink(0.1, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    text "o" at delayed_blink(0.2, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    text "u" at delayed_blink(0.3, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    text "g" at delayed_blink(0.4, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    text "h" at delayed_blink(0.5, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                #text _("WALKTHROUGH") style "shaddyTextBody2"
                                textbutton _("Enabled") action ToggleField(persistent,"inGameWT")

                        hbox:
                            xcenter 0.5
                            ycenter 0.5
                            vbox:
                                style_prefix "slider"
                                hbox:
                                    xcenter 0.27
                                    spacing 5
                                    hbox:
                                        spacing -5
                                        text "T" at delayed_blink(0.4, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "e" at delayed_blink(0.3, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "x" at delayed_blink(0.2, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "t" at delayed_blink(0.1, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    hbox:
                                        spacing -5
                                        text "S" at delayed_blink(0.0, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "i" at delayed_blink(0.0, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "z" at delayed_blink(0.1, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "e" at delayed_blink(0.2, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text ":" at delayed_blink(0.3, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    hbox:
                                        spacing -5
                                        text _("%s" % (persistent.pref_text_size)) at delayed_blink(0.4, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                #text _("TEXT SIZE: %s" % (persistent.pref_text_size)) xcenter 0.26 style "shaddyTextBody1"
                                bar value FieldValue(object=persistent, field='pref_text_size', range=(gui.text_size * 2), max_is_zero=False, style=u'slider', offset=0, step=1) xcenter 0.5

                            vbox:
                                style_prefix "slider"
                                $ opacity = persistent.opacity * 100
                                hbox:
                                    xcenter 0.25
                                    spacing 5
                                    hbox:
                                        spacing -5
                                        text "T" at delayed_blink(0.6, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "e" at delayed_blink(0.5, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "x" at delayed_blink(0.4, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "t" at delayed_blink(0.3, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "b" at delayed_blink(0.2, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "o" at delayed_blink(0.1, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "x" at delayed_blink(0.0, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    hbox:
                                        spacing -5
                                        text "O" at delayed_blink(0.0, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "p" at delayed_blink(0.1, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "a" at delayed_blink(0.2, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "c" at delayed_blink(0.3, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "i" at delayed_blink(0.4, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "t" at delayed_blink(0.5, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text "y" at delayed_blink(0.6, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                        text ":" at delayed_blink(0.7, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                    hbox:
                                        spacing -5
                                        text "[opacity:.0f]%" at delayed_blink(0.8, 2.0) outlines [(3, "#000")] style "shaddyTextBody2"
                                #text _("Textbox Opacity: [opacity:.0f]%") style "shaddyTextBody1"
                                bar value FieldValue(persistent, "opacity", range=1.0, style="slider")

                vbox:
                    label _("")
### Shaddy Additions ###

default persistent.pref_text_size = gui.text_size

init -500 screen quick_menu():
    zorder 100

    if quick_menu:
        hbox:
            style_prefix "quick"
            xalign 0.5
            yalign 1.0
            spacing -10

            textbutton _("Back") action Rollback() text_style "shaddyQMenu"
            textbutton _("History") action ShowMenu('history') text_style "shaddyQMenu"
            textbutton _("Skip") action Skip() alternate Skip(fast=True, confirm=True) text_style "shaddyQMenu"
            textbutton _("Auto") action Preference("auto-forward", "toggle") text_style "shaddyQMenu"
            textbutton _("Save") action ShowMenu('save') text_style "shaddyQMenu"
            textbutton _("Q.S") action QuickSave() text_style "shaddyQMenu"
            textbutton _("Q.L") action QuickLoad() text_style "shaddyQMenu"
            textbutton _("Prefs") action ShowMenu('preferences') text_style "shaddyQMenu"

#        hbox:
#            align(0.995,0.001)
#            textbutton _("CHEATS"):
#                text_style "shaddyCheatButton"
#                action ShowMenu("cheatMenu")
#        hbox:
#            align(0.001, 0.001)
#            textbutton _("STATS"):
#                text_style "shaddyCheatButton"
#                action If(renpy.get_screen("stats_bar"), Hide("stats_bar"), Show("stats_bar"))


init -500 screen quick_menu():
    variant "touch"
    zorder 100

    if quick_menu:
        hbox:
            style_prefix "quick"

            xalign 0.5
            yalign 1.0

            textbutton _("Back") action Rollback() text_style "shaddyQMenu"
            textbutton _("Skip") action Skip() alternate Skip(fast=True, confirm=True) text_style "shaddyQMenu"
            textbutton _("Auto") action Preference("auto-forward", "toggle") text_style "shaddyQMenu"
            textbutton _("Menu") action ShowMenu() text_style "shaddyQMenu"


init -500 screen file_slots(title):

    default page_name_value = FilePageNameInputValue(pattern=_("Page {}"), auto=_("Automatic saves"), quick=_("Quick saves"))

    use game_menu(title):
        fixed:

            ## This ensures the input will get the enter event before any of the
            ## buttons do.
            order_reverse True

            ## The page name, which can be edited by clicking on a button.
            button:
                style "page_label"

                key_events True
                xalign 0.5
                action page_name_value.Toggle()

                input:
                    style "page_label_text"
                    value page_name_value

            ## The grid of file slots.
            grid gui.file_slot_cols gui.file_slot_rows:
                style_prefix "slot"
                xalign 0.5
                yalign 0.5
                spacing gui.slot_spacing

                for i in range(gui.file_slot_cols * gui.file_slot_rows):
                    $ slot = i + 1

                    button:
                        action FileAction(slot)

                        has vbox

                        add FileScreenshot(slot) xalign 0.5

                        text FileTime(slot, format=_("{#file_time}%A, %B %d %Y, %H:%M"), empty=_("empty slot")):
                            style "slot_time_text"

                        text FileSaveName(slot):
                            style "slot_name_text"

                        key "save_delete" action FileDelete(slot)

            if renpy.variant("pc") or renpy.variant("web") and not renpy.variant("mobile"):
                if title == "Save":
                    hbox:
                        style_prefix "page"
                        pos(85, 70)

                        text "Save Name: " style "page_label_text"
                        input:
                            style "page_label_text"
                            pos(5, 0)
                            size 35
                            default "[save_name]"
                            value VariableInputValue("save_name")
                            length 30

            ## Buttons to access other pages.
            hbox:
                style_prefix "page"
                xalign 0.5
                yalign 1.0
                spacing gui.page_spacing

                textbutton _("<") action FilePagePrevious()

                if config.has_autosave:
                    textbutton _("{#auto_page}A") action FilePage("auto")

                if config.has_quicksave:
                    textbutton _("{#quick_page}Q") action FilePage("quick")

                ## range(1, 10) gives the numbers from 1 to 9.
                for page in range(1, 10):
                    textbutton "[page]" action FilePage(page)

                textbutton _(">") action FilePageNext()


init -500 screen say(who, what):
    style_prefix "say"

    window:
        id "window"

        if what != "" and what != None:
            background Transform(Image("gui/textbox.png", xalign=0.5, yalign=1.0), alpha=persistent.opacity)
        else:
            background Transform(Image("gui/textbox.png", xalign=0.5, yalign=1.0), alpha=0)

        if who is not None:

            window:
                id "namebox"
                if who != "" and who != None:
                    background Frame(Transform(Image("gui/namebox.png", gui.namebox_borders, tile=gui.namebox_tile, xalign=gui.name_xalign), alpha=persistent.opacity))
                else:
                    background Frame(Transform(Image("gui/namebox.png", gui.namebox_borders, tile=gui.namebox_tile, xalign=gui.name_xalign), alpha=0))
                style "namebox"
                text who id "who"

        if persistent.say_window_alpha < 0.6:
            text what id "what" size persistent.pref_text_size outlines [(3, "#000", 1, 1)]
        else:
            text what id "what" size persistent.pref_text_size outlines [(3, "#000", 1, 1)]

    if not renpy.variant("small"):
        add SideImage() xalign 0.0 yalign 1.0

init -500 screen input(prompt):
    style_prefix "input"

    if renpy.variant("android"):

        window:
            background Transform(Image("gui/textbox.png", xalign=0.5, yalign=0), alpha=persistent.opacity)

            has vbox:
                xalign gui.dialogue_text_xalign
                xpos gui.dialogue_xpos
                xsize gui.dialogue_width
                ypos gui.dialogue_ypos

            text prompt style "input_prompt" outlines [(3, "#000", 1, 1)]
            input id "input" outlines [(3, "#000", 1, 1)]

    else:

        window:
            background Transform(Image("gui/textbox.png", xalign=0.5, yalign=1.0), alpha=persistent.opacity)

            has vbox:
                xalign gui.dialogue_text_xalign
                xpos gui.dialogue_xpos
                xsize gui.dialogue_width
                ypos gui.dialogue_ypos

            text prompt style "input_prompt"
            input id "input"


init -500 screen choice(items):
    style_prefix "choice"

    vbox:
        for i in items:
            if i.action:

                if persistent.inGameWT:
                    textbutton "{pre}{caption}{post}".format(pre=i.kwargs.get("pre", ""), caption=i.caption, post=i.kwargs.get("post", "")):
                        style "choice_button"
                        action i.action
                        sensitive not i.kwargs.get("disabled", False)
                else:
                    $ disabled = i.kwargs.get("disabled", False)
                    textbutton i.caption action i.action sensitive not disabled style "choice_button"

            else:
                textbutton i.caption style "menu_caption"

## (pre="", post=""):

label Rename:
    scene black
    $ name = renpy.input ("What's your name?", "Lant").strip() or "Lant"
    $ s_name = renpy.input ("What is your relation to the girl you are looking for? (similar age)", "housemate") or "housemate"
    $ b_name = renpy.input ("What are you to her?", "housemate") or "housemate"

    return

style shaddyQMenu is button_text:
    size 20
    outlines [(3,"#000",1,1)]

style shaddyTextBoxHeader is text:
    size 60
    outlines [(3,"#000",1,1)]
    color "#0ed6f9"
    font "shaddyMod/212 Leahlee Sans.otf"
